package cidss;

import cidss.Protocols.Protocols;
import cidss.Sources.Sources;
import cidss.Destinations.Destinations;
import cidss.Patterns.Patterns;
import cidss.Session.*;
import java.util.Vector;

public class cidss {

  public boolean enabled;
  public String sig_source; // shows IDS the signature comes from
  public String description; // signature description (cve references, and others)
  public String action; // what should be done after

  // Protocols
  public Protocols protocols;

  // Sources
  public Sources sources;

  // Destinations
  public Destinations destinations;

  // Patterns
  public Patterns patterns;

  // Session
  public Session session;


  public int logged_packets; // number of packet logged after alarm occurs
  public String message; // what mesage text should be send to You after alarm
  public Vector comment; // additional comments for rule

  public boolean success;
  public String result = "";


  public cidss() {
    sources = new Sources();
    destinations = new Destinations();
    protocols = new Protocols();
    patterns = new Patterns();
    session = new Session();
    comment = new Vector();
  }

  public String getDescribe() {
    String s = "";
    s += "\n----------------------------------------------------\n";
    s += "\nCIDSS Signature:\n";
    s += "\nenabled: " + enabled;
    s += "\naction: " + action;
//    s += "\nprotocol: " + cidss.protocol;
    s += "\nsignature source: " + sig_source;
    s += "\ndescription: " + description;

    s += protocols.getDescribe();
    s += sources.getDescribe();
    s += destinations.getDescribe();
    s += patterns.getDescribe();

    s += "\nMessage send after alarm: " + message;
    s += "\nNumber of packets logged: " + logged_packets;
//    s += "\nSearch depth: " + cidss.search_depth;
    for(int i=0; i<comment.size(); i++)
      s += "\nComment["+i+"]: " + comment.get(i).toString();

    s += "\nSignature translated successfully: " + success;
    s += "\n------------------------------------------------------\n";

    return s;
  }
}
