package ids;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class DataGui extends JFrame{

    Parse dbase;
    XMLSignatures xmlSign;
    Container cp = getContentPane();
    JScrollPane jsp;
    public static JTree tree;
    JButton toTranslator = new JButton("To Translator");
    JButton delete = new JButton("Delete this signature");
    final Gui gui;

    public DataGui(Gui i){
        super("Data Base");
        super.setBounds(20, 20, 300, 400);
        gui = i;

        xmlSign = new XMLSignatures();
        jsp = new JScrollPane(tree);
        cp.add(jsp);
        cp.add("South", toTranslator);
        cp.add("North", delete);

        delete.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                xmlSign.removeSignature();
                cp.remove(jsp);
                jsp = new JScrollPane(tree);
                cp.add(jsp);
                cp.repaint();
                show();
            }
        });

        toTranslator.addActionListener(new ActionListener(){
            public void actionPerformed(ActionEvent e){
                CommonSignature comS = xmlSign.dataToCommmon();
                if(comS != null)
                    gui.fromDataBase(comS);
            }
        });
    }
    public static void setTree(JTree t) {
		tree = t;
    }

    public static JTree getTree() {
		return tree;
    }

    public void createFile(){
        gui.log.addLog("Creating empty document...");
        Parse.createEmptyDocument();
        cp.remove(jsp);
        jsp = new JScrollPane(tree);
        cp.add(jsp);
        cp.repaint();
        show();
    }
    public void openFile(File f){
        gui.log.addLog("Opening file  " + f.getName());
        cp.remove(jsp);
        jsp = new JScrollPane(tree);
        cp.add(jsp);
        cp.repaint();
        show();
		dbase = new Parse(f);
        cp.remove(jsp);
        jsp = new JScrollPane(tree);
        cp.add(jsp);
        cp.repaint();
        show();
    }

    public void addSignature(CommonSignature signature){
        xmlSign.addSignature(signature);
        cp.remove(jsp);
        jsp = new JScrollPane(tree);
        cp.add(jsp);
        cp.repaint();
        show();
    }

    public void saveFile(){
        File f = new File(OptionsPane.getDataBaseFile());
        saveFile(f);
    }

    public void saveFile(File f){
        Parse.saveToFile(f);
    }
}

