package ids;

import java.io.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;


public
class Gui extends JFrame{

	CommonSignature cs1, cs2;
        /**
         * @todo dragon, realsecure
         */
//        DragonSignature ds1, ds2;
	SnortSignature ss1, ss2;
//	RealSecureSignature rs1, rs2;

	Container cp = getContentPane();

	JButton exitButton = new JButton("Exit");

	JMenuBar menu = new JMenuBar();
	JMenu file = new JMenu("File");
	JMenu help = new JMenu("Help");
	JMenu settings = new JMenu("Settings");
	JMenuItem general = new JMenuItem("General Settings");
	JMenuItem errLog = new JMenuItem("Operation Log Window");
	JMenuItem creator = new JMenuItem("Signature Creator");
	JMenuItem exit = new JMenuItem("Exit");
	JMenuItem about = new JMenuItem("About Translator");
	JMenuItem datGui = new JMenuItem("DataBase Panel");
	JMenuItem newData = new JMenuItem("Create empty database");
	JMenuItem openData = new JMenuItem("Open database");
	JMenuItem saveData = new JMenuItem("Save database");
	JMenuItem saveDataAs = new JMenuItem("Save database as...");

	JPanel panel1 = new JPanel();
	JPanel panel2 = new JPanel();
	JPanel panel3 = new JPanel();
	JPanel panel4 = new JPanel();

	String[] systems = {"CIDSS", "Dragon", "Snort", "RealSecure"};

	JComboBox sys1 = new JComboBox(systems);
	JComboBox sys2 = new JComboBox(systems);

	ImageIcon transl_icon = new ImageIcon("strzalka.gif");
	JButton translate = new JButton("TRANSLATE", transl_icon);

	JButton addToBase1 = new JButton("send to base");
	JButton addToBase2 = new JButton("send to base");

	JTextArea sig1a = new JTextArea("\n\n                    signature 1");
	JTextArea sig2a = new JTextArea("\n\n                    signature 2");
	JTextArea sig1b = new JTextArea("\n\n                    signature 1");
	JTextArea sig2b = new JTextArea("\n\n                    signature 2");
	JScrollPane jsp1a = new JScrollPane(sig1a);
	JScrollPane jsp2a = new JScrollPane(sig2a);
	JScrollPane jsp1b = new JScrollPane(sig1b);
	JScrollPane jsp2b = new JScrollPane(sig2b);
	JTabbedPane tb1 = new JTabbedPane(JTabbedPane.TOP);
	JTabbedPane tb2 = new JTabbedPane(JTabbedPane.TOP);

	OptionsPane opt;
	LogPane log;
	DataGui dGui;
	SignatureCreator sc;

	public Gui(){
		super("Signature Translator");
		addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				dispose();
				System.exit(0);
			}
		});

		opt = new OptionsPane();
		log = new LogPane();
		dGui = new DataGui(this);
		sc = new SignatureCreator(this);

		file.add(newData);
		file.add(openData);
		file.add(saveData);
		file.add(saveDataAs);
		file.add(datGui);
		file.add(exit);

		menu.add(file);
		settings.add(general);
		settings.add(errLog);
		settings.add(creator);
		menu.add(settings);
		help.add(about);
		menu.add(help);
		setJMenuBar(menu);

		cp.setLayout(null);
		panel1.setLayout(null);
		panel2.setLayout(null);
		panel3.setLayout(null);
		panel4.setLayout(null);

		panel1.setBounds(0, 0, 120, 270);
		panel2.setBounds(120, 0, 660, 270);
		panel3.setBounds(0, 271, 120, 540);
		panel4.setBounds(120, 271, 660, 540);

		sys1.setBounds(3, 24, 116, 20);
		sys1.setSelectedIndex(2);
		sys2.setBounds(3, 24, 116, 20);
		sys2.setSelectedIndex(0);
		translate.setBounds(3, 230, 117, 40);
		jsp1a.setBounds(3, 0, 650, 250);
		jsp2a.setBounds(3, 0, 650, 250);

		addToBase1.setBounds(3, 50, 115, 25);
		addToBase2.setBounds(3, 50, 115, 25);

		sig1a.setLineWrap(true);
		sig2a.setLineWrap(true);

		jsp1b.setBounds(3, 0, 650, 250);
		jsp2b.setBounds(3, 0, 650, 250);

		sig1b.setLineWrap(true);
		sig1b.setEditable(false);
		sig2b.setLineWrap(true);
		sig2b.setEditable(false);

		tb1.addTab("Normal view", jsp1a);
		tb1.addTab("Describe view", jsp1b);
		tb1.setBounds(3, 0, 650, 250);

		tb2.addTab("Normal view", jsp2a);
		tb2.addTab("Describe view", jsp2b);
		tb2.setBounds(3, 0, 650, 250);

		panel1.add(sys1);
		panel1.add(translate);
		panel1.add(addToBase1);
		panel2.add(tb1);
		panel3.add(sys2);
		panel3.add(addToBase2);
		panel4.add(tb2);

		cp.add(panel1);
		cp.add(panel2);
		cp.add(panel3);
		cp.add(panel4);

		setBounds(50, 50, 800, 600);
		addListeners();
		show();
	}

	void fromDataBase(CommonSignature coms){
		sys1.setSelectedIndex(0);
		tb1.setSelectedIndex(1);
		sig1b.setText(coms.getDescribe());
		cs1 = coms;
	}

	void addListeners(){

		creator.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				sc.setVisible(true);
			}
		});

		newData.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				dGui.createFile();
			}
		});

		openData.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JFileChooser jfc = new JFileChooser(".");
				int result = jfc.showOpenDialog(null);
				if(result == jfc.APPROVE_OPTION){
					File oFile = jfc.getSelectedFile();
					dGui.openFile(oFile);
				}
			}
		});

		saveData.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				dGui.saveFile();
			}
		});

		saveDataAs.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JFileChooser jfc = new JFileChooser(".");
				int result = jfc.showSaveDialog(null);
				if(result == jfc.APPROVE_OPTION){
					File sFile = jfc.getSelectedFile();
					dGui.saveFile(sFile);
				}
			}
		});

		datGui.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				dGui.setVisible(true);
			}
		});

		addToBase1.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if(cs1 != null)
					dGui.addSignature(cs1);
				else
					JOptionPane.showMessageDialog(
						null, "Sorry, but signature hasn't been created yet!", "WARNING",
					  JOptionPane.WARNING_MESSAGE);
			}
		});

		addToBase2.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				if(cs2 != null)
					dGui.addSignature(cs2);
				else
					JOptionPane.showMessageDialog(
						null, "Sorry, but signature hasn't been created yet!", "WARNING",
					  JOptionPane.WARNING_MESSAGE);
			}
		});

		sys1.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
                            /**
                             * @todo dragon
                             */
				cs1 = null;
//				ds1 = null;
				ss1 = null;
				sig1a.setText("");
				sig1b.setText("");
				if(sys1.getSelectedIndex()==0){
					tb1.setSelectedIndex(1);
					tb1.setEnabled(false);
				}else{
					tb1.setSelectedIndex(0);
					tb1.setEnabled(true);
				}
			}
		});

		sys2.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				cs2 = null;
                                /**
                                 * @todo dragon
                                 */
//				ds2 = null;
				ss2 = null;
				sig2a.setText("");
				sig2b.setText("");
				if(sys2.getSelectedIndex()==0){
					tb2.setSelectedIndex(1);
					tb2.setEnabled(false);
				}else{
					tb2.setSelectedIndex(0);
					tb2.setEnabled(true);
				}
			}
		});

		tb1.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e){
				if(tb1.getSelectedIndex() == 1){
					if(sys1.getSelectedIndex() == 1){
                                            /**
                                             * @todo dragon
                                             */
/*						ds1 = new DragonSignature(sig1a.getText());
						if(ds1.success == true)
							sig1b.setText(ds1.getDescribe());
*/
                                               }
                    else if(sys1.getSelectedIndex() ==2){
                        ss1 = new SnortSignature(sig1a.getText());
                        if(ss1.success == true)
                        sig1b.setText(ss1.getDescribe());
                    }
                    else if(sys1.getSelectedIndex() ==3){
                        /**
                         * @todo realsecure
                         */
/*                        rs1 = new RealSecureSignature(sig1a.getText());
                        if(rs1.success == true)
                        sig1b.setText(rs1.getDescribe());
*/
                    }
				}
			}
		});

		tb2.addChangeListener(new ChangeListener(){
			public void stateChanged(ChangeEvent e){
				if(tb2.getSelectedIndex() == 1){
					if(sys2.getSelectedIndex() == 1){
                                            /**
                                             * @todo dragon
                                             */
/*
						ds2 = new DragonSignature(sig2a.getText());
						if(ds2.success == true)
							sig2b.setText(ds2.getDescribe());
*/
					}
                    else if(sys2.getSelectedIndex() ==2){
                        ss2 = new SnortSignature(sig2a.getText());
                        if(ss2.success == true)
                            sig2b.setText(ss2.getDescribe());
                    }
                    else if(sys2.getSelectedIndex() ==3){
                        /**
                         * @todo realsecure
                         */
/*
                        rs2 = new RealSecureSignature(sig2a.getText());
                        if(rs2.success == true)
                            sig2b.setText(rs2.getDescribe());
*/
                  }
				}
			}
		});

		translate.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				log.addLog("\n --------------------------------------");
				int up = sys1.getSelectedIndex();
				int down = sys2.getSelectedIndex();
				if(up == down){
					log.addLog("This translation doesn't make any sense");
					JOptionPane.showMessageDialog(null, "This translation doesn't make any sense");
					log.addLog(" --------------------------------------\n");
					return;
				}

				// Up is CIDSS, down is Dragon
				// CIDSS -> Dragon
				if(up == 0 && down == 1){
					log.addLog("CIDSS -> Dragon Signature translation");
					if(cs1 == null){
						log.addLog("There is none CommonSignature;   FAILED");
						return;
					}
                                        /**
                                         * @todo dragon, realsecure
                                         */
/*
					ds2 = new DragonSignature(cs1);
					log.addLog(ds2.result);
					if(ds2.success == false){
						log.addLog(" --------------------------------------\n");
						return;
					}
					else{
						tb2.setSelectedIndex(0);
						sig2a.setText(ds2.getSignature());
					}
*/
                                 }

                // Up is CIDSS, down is Snort
                // CIDSS -> Snort
                if(up == 0 && down == 2){
                    log.addLog("CIDSS -> Snort Signature translation");
                    if(cs1 == null){
                        log.addLog("There is none CommonSignature;   FAILED");
                        return;
                    }
                    ss2 = new SnortSignature(cs1);
                    log.addLog(ss2.result);
                    if(ss2.success == false){
                        log.addLog(" --------------------------------------\n");
                        return;
                    }
                    else{
                        tb2.setSelectedIndex(0);
                        sig2a.setText(ss2.getSignature());
                    }
                }

                // Up is CIDSS, down is RealSecure
                // CIDSS -> RealSecure
                if(up == 0 && down == 3){
                    log.addLog("CIDSS -> RealSecure Signature translation");
                    if(cs1 == null){
                        log.addLog("There is none CommonSignature;   FAILED");
                        return;
                    }
                    /**
                     * @todo realsecure
                     */
/*
                    rs2 = new RealSecureSignature(cs1);
                    log.addLog(rs2.result);
                    if(rs2.success == false){
                        log.addLog(rs2.result+"\n");
                        log.addLog(" --------------------------------------\n");
                        return;
                    }
                    else{
                        tb2.setSelectedIndex(0);
                        sig2a.setText(rs2.getSignature());
                    }
*/
                }

				// Up is Dragon, down is CIDSS
				// Dragon -> CIDSS

                                /**
                                 * @todo dragon, realsecure
                                 */
/*
				if(up == 1 && down == 0){
					log.addLog("Dragon -> CIDSS Signature translation");
					ds1 = new DragonSignature(sig1a.getText());
					log.addLog(ds1.result);
					if(ds1.success == false){
						log.addLog(" --------------------------------------\n");
						return;
					}
					cs2 = ds1.toCommon();
					log.addLog(cs2.result);
					cs2.printToConsole();
					tb2.setSelectedIndex(1);
					sig2b.setText(cs2.getDescribe());
				}

				// Up is Dragon, down is Snort
				// Dragon -> Snort
				if(up == 1 && down == 2){
					log.addLog("Dragon -> Snort translation");
					ds1 = new DragonSignature(sig1a.getText());
					log.addLog(ds1.result);
					if(ds1.success == false){
						log.addLog(" --------------------------------------\n");
						return;
					}
					cs2 = ds1.toCommon();
					log.addLog(cs2.result);
					cs2.printToConsole();
					ss2 = new SnortSignature(cs2);
					log.addLog(ss2.result);
					sig2a.setText(ss2.getSignature());
					ss2.printToConsole();
				}

                // Up is Dragon, down is RealSecure
                // Dragon -> RealSecure
                if(up == 1 && down == 3){
                    log.addLog("Dragon -> RealSecure translation");
                    ds1 = new DragonSignature(sig1a.getText());
                    log.addLog(ds1.result);
                    if(ds1.success == false){
                        log.addLog(" --------------------------------------\n");
                        return;
                    }
                    cs2 = ds1.toCommon();
                    log.addLog(cs2.result);
                    cs2.printToConsole();
                    rs2 = new RealSecureSignature(cs2);
                    log.addLog(rs2.result);
                    sig2a.setText(rs2.getSignature());
                    rs2.printToConsole();
                }

*/
				// Up is Snort, down is CIDSS
				// Snort -> CIDSS
				if(up == 2 && down == 0){
					log.addLog("Snort -> CIDSS translation ");
					ss1 = new SnortSignature(sig1a.getText());
					log.addLog(ss1.result);
					if(ss1.success == false){
						log.addLog(" --------------------------------------\n");
						return;
					}
					cs2 = ss1.toCommon();
					log.addLog(cs2.result);
					cs2.printToConsole();
					tb2.setSelectedIndex(1);
					sig2b.setText(cs2.getDescribe());
				}

				// Up is Snort, down is Dragon
				// Snort -> Dragon
                                /**
                                 * @todo dragon, realsecure
                                 */
/*
				if(up == 2 && down == 1){
					log.addLog("Snort -> Dragon translation ");
					ss1 = new SnortSignature(sig1a.getText());
					log.addLog(ss1.result);
					if(ss1.success == false){
						log.addLog(" --------------------------------------\n");
						return;
					}
					cs2 = ss1.toCommon();
					cs2.printToConsole();
					log.addLog(cs2.result);
					ds2 = new DragonSignature(cs2);
					log.addLog(ds2.result);
					sig2a.setText(ds2.getSignature());
					ds2.printToConsole();
				}
				log.addLog(" --------------------------------------\n");

                // Up is Snort, down is RealSecure
                // Snort -> RealSecure
                if(up == 2 && down == 3){
                    log.addLog("Snort -> RealSecure translation ");
                    ss1 = new SnortSignature(sig1a.getText());
                    log.addLog(ss1.result);
                    if(ss1.success == false){
                        log.addLog(" --------------------------------------\n");
                        return;
                    }
                    cs2 = ss1.toCommon();
                    cs2.printToConsole();
                    log.addLog(cs2.result);
                    rs2 = new RealSecureSignature(cs2);
                    log.addLog(rs2.result);
                    sig2a.setText(rs2.getSignature());
                    rs2.printToConsole();
                }
                log.addLog(" --------------------------------------\n");

				// Up is RealSecure, down is CIDSS
				// RealSecure -> CIDSS
				if(up == 3 && down == 0){
					log.addLog("RealSecure -> CIDSS translation ");
					rs1 = new RealSecureSignature(sig1a.getText());
					log.addLog(rs1.result);
					if(rs1.success == false){
						log.addLog(" --------------------------------------\n");
						return;
					}
					cs2 = rs1.toCommon();
					log.addLog(cs2.result);
					cs2.printToConsole();
					tb2.setSelectedIndex(1);
					sig2b.setText(cs2.getDescribe());
				}

                // Up is RealSecure, down is Dragon
                // RealSecure -> Dragon
                if(up == 3 && down == 1){
                    log.addLog("RealSecure -> Dragon translation ");
                    rs1 = new RealSecureSignature(sig1a.getText());
                    log.addLog(rs1.result);
                    if(rs1.success == false){
                        log.addLog(" --------------------------------------\n");
                        return;
                    }
                    cs2 = rs1.toCommon();
                    cs2.printToConsole();
                    log.addLog(cs2.result);
                    ds2 = new DragonSignature(cs2);
                    log.addLog(ds2.result);
                    sig2a.setText(ds2.getSignature());
                    ds2.printToConsole();
                }
                log.addLog(" --------------------------------------\n");

                // Up is RealSecure, down is Snort
                // RealSecure -> Snort
                if(up == 3 && down == 2){
                    log.addLog("RealSecure -> Snort translation ");
                    rs1 = new RealSecureSignature(sig1a.getText());
                    log.addLog(rs1.result);
                    if(rs1.success == false){
                        log.addLog(" --------------------------------------\n");
                        return;
                    }
                    cs2 = rs1.toCommon();
                    cs2.printToConsole();
                    log.addLog(cs2.result);
                    ss2 = new SnortSignature(cs2);
                    log.addLog(ss2.result);
                    sig2a.setText(ss2.getSignature());
                    ss2.printToConsole();
                }

*/
                log.addLog(" --------------------------------------\n");

			}
		});

		about.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				JOptionPane.showMessageDialog(null, "\n       Signatures Translator of IDS systems         \n" +
													"         Homepage: http://translator.b59.net \n\n" +
											  		"            First version: Krystian Miakisz\n\n" +
                                                    "                       Continuation:\n" +
                                                    "            Tomasz Kruszona, Jacek Kalinski\n\n\n" +
											  		"                          PJWSTK 2004\n\n");
			}
		});

		exit.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				int k = JOptionPane.showConfirmDialog(null, "Really exit?");
				if(k == 0)
					System.exit(0);
			}
		});

		general.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				opt.setVisible(true);
			}
		});

		errLog.addActionListener(new ActionListener(){
			public void actionPerformed(ActionEvent e){
				log.setVisible(true);
			}
		});
	}
}








