package ids;

import java.io.*;
import javax.swing.*;

public
class Translator{

	static Gui gui;
        private static boolean startInGui = false;
        public static String commonXSD = "common.xsd";
        public static String signatureXML = "signatures.xml";
        public static File inputFile = new File(signatureXML);
        public static File outputFile = new File("");
        public static String translateFrom = "Snort";
        public static String translateTo = "CIDSS";

	public static void main(String[] args){
          if (args.length == 0)
            startInGui = true;
          for (int i = 0; i < args.length; i++) {
            if ( (args[i].length() > 1 &&
                  (args[i].substring(0, 2).equalsIgnoreCase("-h") ||
                   args[i].substring(0, 2).equalsIgnoreCase("/h"))) ||
                (args[i].length() > 2 &&
                 args[i].substring(0, 3).equalsIgnoreCase("--h")))
              help();
            else if (args[i].equals("-g"))
              startInGui = true;
            else if (args[i].equals("-c")) {
              if (i + 1 < args.length)
                commonXSD = args[i + 1];
              else {
                System.err.println("Argument '-c' require an existing filename");
                System.exit(1);
              }
              File tmpFile = new File(commonXSD);
              if (!tmpFile.exists() || !tmpFile.canRead()) {
                System.err.println("'" + commonXSD +
                                   "' file not exists or is not readable");
                System.exit(2);
              }
              i++;
              continue;
            } else if (args[i].equals("-s")) {
                if (i + 1 < args.length)
                  signatureXML = args[i + 1];
                else {
                  System.err.println("Argument '-s' require an existing filename");
                  System.exit(1);
                }
                File tmpFile = new File(signatureXML);
                if (!tmpFile.exists() || !tmpFile.canRead()) {
                  System.err.println("'" + signatureXML +
                                     "' file not exists or is not readable");
                  System.exit(2);
                }
                i++;
                continue;
            } else if (args[i].equals("-i")) {
                if (i + 1 < args.length)
                  inputFile = new File(args[i + 1]);
                else {
                  System.err.println("Argument '-i' require an existing filename");
                  System.exit(1);
                }
                if (!inputFile.exists() || !inputFile.canRead()) {
                  System.err.println("Input file not exists or is not readable");
                  System.exit(2);
                }
                i++;
                continue;
            } else if (args[i].equals("-o")) {
                if (i + 1 < args.length)
                  inputFile = new File(args[i+1]);
                else {
                  System.err.println("Argument '-o' require a parameter (see -h for help)");
                  System.exit(1);
                }
                i++;
                continue;
              } else if (args[i].equals("-f")) {
                  if (i + 1 < args.length)
                    translateFrom = args[i + 1];
                  else {
                    System.err.println("Invalid parameter of '-f'. See '-h' for help");
                    System.exit(1);
                  }
                  i++;
                  continue;
                } else if (args[i].equals("-t")) {
                    if (i + 1 < args.length)
                      translateTo = args[i + 1];
                    else {
                      System.err.println("Invalid parameter of '-t'. See '-h' for help");
                      System.exit(1);
                    }
                    i++;
                    continue;
              } else {
                System.err.println("Unknown switch: " + args[i]);
                System.exit(1);
              }

          }
          if (!inputFile.exists() || !inputFile.canRead()) {
            System.err.println("Input file not exists or is not readable: "+inputFile.getAbsolutePath());
            System.exit(2);
          }
          if (startInGui)
            startGUI();
          else
            System.exit(0);
        }

        private static void startGUI() {
          try {
            UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
          }
          catch (Exception e) {}
          System.out.println("Constructing Graphic User Interface...");
          gui = new Gui();
        }

        private static void help() {
          System.err.println("Commandline signature translator");
          System.err.println("Syntax:");
          System.err.println("\t-h\tthis screen");
          System.err.println("\t-g\tstart in GUI mode");
          System.err.println("\t-c\tsignatures XSD schema (default: "+commonXSD+")");
          System.err.println("\t-s\tsignatures database (default: "+signatureXML+")");
          System.err.println("\t-i\tinput signature file (default: "+inputFile.toString()+")");
          System.err.println("\t-o\toutput signature file (if no specified, wirte to stdout)");
          System.err.println("\t-f\ttranslate from: cidss, snort, dragon, shoki*, realsecure*");
          System.err.println("\t-t\ttranslate to: cidss, snort, dragon, shoki*, realsecure*");
          System.err.println("");
          System.err.println("* - partial or beta implementation");
        }
}
