package ids;

import javax.swing.*;

public class XMLSignatures extends Parse{

    public XMLSignatures(){
    }

    public void addSignature(CommonSignature cs) {

        org.w3c.dom.Node node;
	node = document.getLastChild();

        org.w3c.dom.Element signature = document.createElement("Signature"),
            enabled = document.createElement("Enabled"),
            sig_source = document.createElement("Sig_source"),
            description = document.createElement("Description"),
            action  = document.createElement("Action"),

            logged_packets = document.createElement("Logged_packets"),
//            search = document.createElement("Search_depth"),
            message = document.createElement("Message"),
            comment = document.createElement("Comment");


        org.w3c.dom.Element
            protocols = document.createElement("Protocols"),
            sources = document.createElement("Sources"),
            destinations = document.createElement("Destinations"),
            patterns = document.createElement("Patterns"),
            protocol = document.createElement("Protocol"),
            source = document.createElement("Source"),
            destination = document.createElement("Destination"),
            pattern = document.createElement("Pattern"),
            session = document.createElement("Session"),
            session_end = document.createElement("Session_End"),
            session_identification = document.createElement("Session_Identification"),
            session_instructions = document.createElement("Session_Instructions"),
            session_case = document.createElement("Session_Case"),
            session_case_state_instructions = document.createElement("Case_State_Instructions");


        org.w3c.dom.Element
            tcp_ack = document.createElement("TCP_Ack"),
            tcp_state = document.createElement("TCP_State"),
            tcp_seq = document.createElement("TCP_Seq"),
            tcp_dsize = document.createElement("TCP_Dsize"),
            tcp_flags = document.createElement("TCP_Flags"),
            tcp_window = document.createElement("TCP_Window"),
            udp_dsize = document.createElement("UDP_Dsize"),
            icmp_dsize = document.createElement("ICMP_Dsize"),
            icmp_icmp_id = document.createElement("ICMP_Icmp_Id"),
            icmp_icmp_seq = document.createElement("ICMP_Icmp_Seq"),
            icmp_icode = document.createElement("ICMP_Icode"),
            icmp_itype = document.createElement("ICMP_Itype"),
            ip_ttl = document.createElement("IP_Ttl"),
            ip_tos = document.createElement("IP_Tos"),
            ip_fragbits = document.createElement("IP_Fragbits"),
            ip_id = document.createElement("IP_Id"),
            ip_ip_proto = document.createElement("IP_Ip_Proto"),
            ip_dsize = document.createElement("IP_Dsize"),
            ip_ipopts = document.createElement("IP_Ipopts"),
            isdataat = document.createElement("Isdataat"),
            rpc = document.createElement("Rpc");



        org.w3c.dom.Element
            proto_logic = document.createElement("Proto_Logic"),
            src_logic = document.createElement("Src_Logic"),
            source_ip = document.createElement("Source_IP"),
            source_port = document.createElement("Source_Port"),
            dst_logic = document.createElement("Dst_Logic"),
            destination_ip = document.createElement("Destination_IP"),
            destination_port = document.createElement("Destination_Port"),
            pat_logic = document.createElement("Pat_Logic"),
            pattern_type = document.createElement("Pattern_Type"),
            pattern_content = document.createElement("Pattern_Content"),
            pattern_depth = document.createElement("Pattern_Depth"),
            pattern_uricontent = document.createElement("Pattern_Uricontent"),
            pattern_offset = document.createElement("Pattern_Offset"),
            pattern_within = document.createElement("Pattern_Within"),
            pattern_distance = document.createElement("Pattern_Distance");


        String sid = null;
        int id = -1;
        do {
          sid = JOptionPane.showInputDialog(
              null, "Please specify unique integer ID for a new signature");
          if (sid == null)
            return;
          if (sid != "") {
            try {
              id = Integer.parseInt(sid);
            } catch (NumberFormatException ex) {
              id = -1;
            }
          }
        } while(sid == "" || id == -1);
        signature.setAttribute("sid", "" + id);

        enabled.appendChild(document.createTextNode(String.valueOf(cs.cidss.enabled)));
        signature.appendChild(enabled);

        sig_source.appendChild(document.createTextNode(cs.cidss.sig_source));
        signature.appendChild(sig_source);

        description.appendChild(document.createTextNode(cs.cidss.description));
        signature.appendChild(description);

        action.appendChild(document.createTextNode(cs.cidss.action));
        signature.appendChild(action);

        /**
         * @todo Protocols i podklucze...
         */

        for (int j=0; j<cs.cidss.protocols.protocol.size(); j++) {
          protocol = document.createElement("Protocol");
          cidss.Protocols.Protocol p = (cidss.Protocols.Protocol)cs.cidss.protocols.protocol.get(j);

          if (p.tcp_ack != 0) {
            tcp_ack = document.createElement("TCP_Ack");
            tcp_ack.appendChild(document.createTextNode("" + p.tcp_ack));
            protocol.appendChild(tcp_ack);
          }

          if (p.tcp_state != null) {
            tcp_state = document.createElement("TCP_State");
            tcp_state.appendChild(document.createTextNode(p.tcp_state));
            protocol.appendChild(tcp_state);
          }

          if (p.tcp_seq != 0) {
            tcp_seq = document.createElement("TCP_Seq");
            tcp_seq.appendChild(document.createTextNode("" + p.tcp_seq));
            protocol.appendChild(tcp_seq);
          }

          if (p.tcp_dsize != null) {
            tcp_dsize = document.createElement("TCP_Dsize");
            tcp_dsize.appendChild(document.createTextNode(p.tcp_dsize));
            protocol.appendChild(tcp_dsize);
          }

          if (p.tcp_flags != null) {
            tcp_flags = document.createElement("TCP_Flags");
            tcp_flags.appendChild(document.createTextNode(p.tcp_flags));
            protocol.appendChild(tcp_flags);
          }

          if (p.tcp_window != 0) {
            tcp_window = document.createElement("TCP_Window");
            tcp_window.appendChild(document.createTextNode("" + p.tcp_window));
            protocol.appendChild(tcp_window);
          }

          if (p.udp_dsize != null) {
            udp_dsize = document.createElement("UDP_Dsize");
            udp_dsize.appendChild(document.createTextNode(p.udp_dsize));
            protocol.appendChild(udp_dsize);
          }

          if (p.icmp_dsize != null) {
            icmp_dsize = document.createElement("ICMP_Icmp_Id");
            icmp_dsize.appendChild(document.createTextNode(p.icmp_dsize));
            protocol.appendChild(icmp_dsize);
          }

          if (p.icmp_icmp_id != 0) {
            icmp_icmp_id = document.createElement("ICMP_Icmp_Id");
            icmp_icmp_id.appendChild(document.createTextNode("" + p.icmp_icmp_id));
            protocol.appendChild(icmp_icmp_id);
          }

          if (p.icmp_icmp_seq != 0) {
            icmp_icmp_seq = document.createElement("ICMP_Icmp_Seq");
            icmp_icmp_seq.appendChild(document.createTextNode("" + p.icmp_icmp_seq));
            protocol.appendChild(icmp_icmp_seq);
          }

          if (p.icmp_icode != null) {
            icmp_icode = document.createElement("ICMP_Icode");
            icmp_icode.appendChild(document.createTextNode(p.icmp_icode));
            protocol.appendChild(icmp_icode);
          }

          if (p.icmp_itype != null) {
            icmp_itype = document.createElement("ICMP_Itype");
            icmp_itype.appendChild(document.createTextNode(p.icmp_itype));
            protocol.appendChild(icmp_itype);
          }

          if (p.ip_ttl != null) {
            ip_ttl = document.createElement("IP_Ttl");
            ip_ttl.appendChild(document.createTextNode(p.ip_ttl));
            protocol.appendChild(ip_ttl);
          }

          if (p.ip_tos != 0) {
            ip_tos = document.createElement("IP_Tos");
            ip_tos.appendChild(document.createTextNode("" + p.ip_tos));
            protocol.appendChild(ip_tos);
          }

          if (p.ip_fragbits != null) {
            ip_fragbits = document.createElement("IP_Fragbits");
            ip_fragbits.appendChild(document.createTextNode(p.ip_fragbits));
            protocol.appendChild(ip_fragbits);
          }

          if (p.ip_id != 0) {
            ip_id = document.createElement("IP_Id");
            ip_id.appendChild(document.createTextNode("" + p.ip_id));
            protocol.appendChild(ip_id);
          }

          if (p.ip_ip_proto != null) {
            ip_ip_proto = document.createElement("IP_Ip_Proto");
            ip_ip_proto.appendChild(document.createTextNode(p.ip_ip_proto));
            protocol.appendChild(ip_ip_proto);
          }

          if (p.ip_dsize != null) {
            ip_dsize = document.createElement("IP_Dsize");
            ip_dsize.appendChild(document.createTextNode(p.ip_dsize));
            protocol.appendChild(ip_dsize);
          }

          if (p.ip_ipopts != null) {
            ip_ipopts = document.createElement("IP_Ipopts");
            ip_ipopts.appendChild(document.createTextNode(p.ip_ipopts));
            protocol.appendChild(ip_ipopts);
          }

          if (p.isdataat != null) {
            isdataat = document.createElement("Isdataat");
            isdataat.appendChild(document.createTextNode(p.isdataat));
            protocol.appendChild(isdataat);
          }

          if (p.rpc != null) {
            rpc = document.createElement("Rpc");
            rpc.appendChild(document.createTextNode(p.rpc));
            protocol.appendChild(rpc);
          }

          // protocol
          protocol.setAttribute("proto_id",String.valueOf(j));
          protocol.setAttribute("Type", p.type);
          protocols.appendChild(protocol);
        }

        // protocols
        if (cs.cidss.protocols.proto_logic != null) {
          proto_logic.appendChild(document.createTextNode(cs.cidss.protocols.proto_logic));
          protocols.appendChild(proto_logic);
        }

        signature.appendChild(protocols);


        for (int j=0; j<cs.cidss.sources.source.size(); j++) {
          source = document.createElement("Source");
          cidss.Sources.Source s = (cidss.Sources.Source)cs.cidss.sources.source.get(j);
          source_ip = document.createElement("Source_IP");
          source_ip.appendChild(document.createTextNode(s.source_ip));
          source_port = document.createElement("Source_Port");
          source_port.appendChild(document.createTextNode(s.source_port));
          if (s.source_ip_neg == true)
            source_ip.setAttribute("Neg",String.valueOf(s.source_ip_neg));
          if (s.source_ip_mask.trim().length() > 0)
            source_ip.setAttribute("Mask",s.source_ip_mask);

          // source
          source.appendChild(source_ip);
          source.appendChild(source_port);
          source.setAttribute("src_id",String.valueOf(j));
          sources.appendChild(source);
        }
        // sources
        if (cs.cidss.sources.src_logic != null) {
          src_logic.appendChild(document.createTextNode(cs.cidss.sources.src_logic));
          sources.appendChild(src_logic);
        }
        signature.appendChild(sources);


        for (int j=0; j<cs.cidss.destinations.destination.size(); j++) {
          destination = document.createElement("Destination");
          cidss.Destinations.Destination d = (cidss.Destinations.Destination)cs.cidss.destinations.destination.get(j);
          destination_ip = document.createElement("Destination_IP");
          destination_ip.appendChild(document.createTextNode(d.destination_ip));
          destination_port = document.createElement("Destination_Port");
          destination_port.appendChild(document.createTextNode(d.destination_port));
          if (d.destination_ip_neg == true)
            destination_ip.setAttribute("Neg",String.valueOf(d.destination_ip_neg));
          if (d.destination_ip_mask.trim().length() > 0)
            destination_ip.setAttribute("Mask",d.destination_ip_mask);

          // destination
          destination.appendChild(destination_ip);
          destination.appendChild(destination_port);
          destination.setAttribute("dst_id",String.valueOf(j));
          destinations.appendChild(destination);
        }
        // destinations
        if (cs.cidss.destinations.dst_logic != null) {
          dst_logic.appendChild(document.createTextNode(cs.cidss.destinations.dst_logic));
          destinations.appendChild(dst_logic);
        }
        signature.appendChild(destinations);


        for (int j=0; j<cs.cidss.patterns.pattern.size(); j++) {
          pattern = document.createElement("Pattern");
          cidss.Patterns.Pattern p = (cidss.Patterns.Pattern)cs.cidss.patterns.pattern.get(j);

          if (p.pattern_type != null) {
            pattern_type = document.createElement("Pattern_Type");
            pattern_type.appendChild(document.createTextNode(p.pattern_type));
            pattern.appendChild(pattern_type);
          }
          if (p.pattern_content != null) {
            pattern_content = document.createElement("Pattern_Content");
            pattern_content.appendChild(document.createTextNode(p.pattern_content));
            pattern_content.setAttribute("CaseSensitive", String.valueOf(p.pattern_content_casesensitive));
            pattern_content.setAttribute("RawBytes", String.valueOf(p.pattern_content_rawbytes));
            pattern.appendChild(pattern_content);
          }
          if (p.pattern_depth != 0) {
            pattern_depth = document.createElement("Pattern_Depth");
            pattern_depth.appendChild(document.createTextNode("" + p.pattern_depth));
            pattern.appendChild(pattern_depth);
          }
          if (p.pattern_uricontent != null) {
            pattern_uricontent = document.createElement("Pattern_Uricontent");
            pattern_uricontent.appendChild(document.createTextNode(p.pattern_uricontent));
            pattern.appendChild(pattern_uricontent);
          }
          if (p.pattern_offset != 0) {
            pattern_offset = document.createElement("Pattern_Offset");
            pattern_offset.appendChild(document.createTextNode("" + p.pattern_offset));
            pattern.appendChild(pattern_offset);
          }
          if (p.pattern_within != 0) {
            pattern_within = document.createElement("Pattern_Within");
            pattern_within.appendChild(document.createTextNode("" + p.pattern_within));
            pattern.appendChild(pattern_within);
          }
          if (p.pattern_distance != 0) {
            pattern_distance = document.createElement("Pattern_Distance");
            pattern_distance.appendChild(document.createTextNode("" + p.pattern_distance));
            pattern.appendChild(pattern_distance);
          }

          pattern.setAttribute("pat_id",String.valueOf(j));
          patterns.appendChild(pattern);
        }
        // patterns
        if (cs.cidss.patterns.pat_logic != null) {
          pat_logic.appendChild(document.createTextNode(cs.cidss.patterns.pat_logic));
          patterns.appendChild(pat_logic);
        }
        signature.appendChild(patterns);

        if (cs.cidss.logged_packets != 0) {
          logged_packets.appendChild(document.createTextNode("" + cs.cidss.logged_packets));
          signature.appendChild(logged_packets);
        }

        message.appendChild(document.createTextNode(cs.cidss.message));
        signature.appendChild(message);

        for (int i = 0; i < cs.cidss.comment.size(); i++) {
          comment.appendChild(document.createTextNode("" + cs.cidss.comment.get(i)));
          signature.appendChild(comment);
        }

        /**
         * @todo Sessions
         */

/*
        if (cs.cidss.session.Session_End.Session_Timeout != null)
          session_end.appendChild(document.createTextNode(cs.cidss.session.Session_End.Session_Timeout));
        session_end.appendChild(document.createTextNode(String.valueOf(cs.cidss.session.Session_End.Session_Pckt_Count)));

        session_identification.appendChild(document.createTextNode(String.valueOf(cs.cidss.session.Session_Identification.Same_Source_IP)));
        session_identification.appendChild(document.createTextNode(String.valueOf(cs.cidss.session.Session_Identification.Same_Source_Port)));
        session_identification.appendChild(document.createTextNode(String.valueOf(cs.cidss.session.Session_Identification.Same_Destination_IP)));
        session_identification.appendChild(document.createTextNode(String.valueOf(cs.cidss.session.Session_Identification.Same_Destination_Port)));
        session_identification.appendChild(document.createTextNode(String.valueOf(cs.cidss.session.Session_Identification.Same_Protocol)));
        session_identification.appendChild(document.createTextNode(String.valueOf(cs.cidss.session.Session_Identification.Same_Direction)));
        signature.appendChild(session);

*/
            /**
             * @todo fix this! stare jakies...
             */

/*
            for(int i=0; i<cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Isset_Var.length; i++) {
              session_case_state_instructions.appendChild(document.createTextNode(cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Isset_Var[i]));
              session_case_state_instructions.setAttribute("var",cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Isset_Var_var[i]);
            }
            for(int i=0; i<cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Compare_Var.length; i++) {
              session_case_state_instructions.appendChild(document.createTextNode(cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Compare_Var[i]));
              session_case_state_instructions.setAttribute("var",cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Compare_Var_var[i]);
              session_case_state_instructions.setAttribute("value",cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Compare_Var_value[i]);
            }
            for(int i=0; i<cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Set_Var.length; i++) {
              session_case_state_instructions.appendChild(document.createTextNode(cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Set_Var[i]));
              session_case_state_instructions.setAttribute("var",cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Set_Var_var[i]);
              session_case_state_instructions.setAttribute("value",cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Set_Var_value[i]);
            }
            for(int i=0; i<cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Isset_Var.length; i++) {
              session_case_state_instructions.appendChild(document.createTextNode(cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Unset_Var[i]));
              session_case_state_instructions.setAttribute("var",cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Instructions.Unset_Var_var[i]);
            }

            session_case.appendChild(document.createTextNode(cs.cidss.session.Session_Instructions.Session_Case[0].Case_Filter));
            session_case.appendChild(document.createTextNode(cs.cidss.session.Session_Instructions.Session_Case[0].Direction));
            session_case.appendChild(document.createTextNode(cs.cidss.session.Session_Instructions.Session_Case[0].Case_State_Condition));
            session_case.appendChild(session_case_state_instructions);

            session.appendChild(document.createTextNode(cs.cidss.session.Session_Filter));
            session.appendChild(document.createTextNode(cs.cidss.session.Session_Start));
            session.appendChild(session_end);
            session.appendChild(session_identification);
            session_instructions.appendChild(session_case);
            session.appendChild(session_instructions);
     */



//		System.out.println("1:"+node);
//		System.out.println("2:"+addNode);
            node.appendChild(signature);
            DomToTreeModelAdapter dttma = new DomToTreeModelAdapter();
            JTree tree = new JTree(dttma);
            DataGui.setTree(tree);
    }
    public void removeSignature(){
	JTree tree = DataGui.getTree();
        if(tree == null || tree.getSelectionPath() == null)
            return;

        String path = tree.getSelectionPath().toString();
        String attrVal;
        org.w3c.dom.NodeList nList;
        org.w3c.dom.Node node = null;
        org.w3c.dom.NodeList nodeList;

        if(path.length() < 52)
            return;

        if(path.substring(0, 51).equals("[Document, Element: Signatures, Element: Signature "))
            attrVal = path.substring(51, path.length()-1);
        else
            return;

        nList= document.getElementsByTagName("Signature");
        for(int i=0; i<nList.getLength(); i++){
            if(nList.item(i).getAttributes().item(0).getNodeValue().equals(attrVal)){
                node = nList.item(i);
                break;
            }
            else if(i == nList.getLength()-1)
                return;
        }

        if (node != null)
          document.getFirstChild().removeChild(node);
        DomToTreeModelAdapter dttma = new DomToTreeModelAdapter();
        tree = new JTree(dttma);
	DataGui.setTree(tree);
    }

    public CommonSignature dataToCommmon(){
      CommonSignature cs = new CommonSignature();
      JTree tree = DataGui.getTree();
      if(tree == null || tree.getSelectionPath() == null)
        return null;
      String path = tree.getSelectionPath().toString();
      String attrVal;
      org.w3c.dom.NodeList nList;
      org.w3c.dom.Node node = null;
      org.w3c.dom.NodeList nodeList;
      org.w3c.dom.NodeList nodeItem;
      org.w3c.dom.NodeList nodeSHosts;
      org.w3c.dom.NodeList nodeDHosts;
      org.w3c.dom.NodeList nodePatt;


//        String sig_source = "unknown";
//        String description = "";
//        String action = "unknown";
//        String protocol = "unknown";
//
//        String source_ip = "unknown";
//        boolean source_ip_neg = false;
//        String source_port = "unknown";
//        boolean source_port_neg = false;
//        String destination_ip = "unknown";
//        boolean destination_ip_neg = false;
//        String destination_port = "unknown";
//        boolean destination_port_neg = false;
//
//        String pattern = "";
//        String pattern_type = "unknown";
//        boolean pattern_neg = false;
//        String message = "";
//        int loged_packets = 0;
//        int search_depth = 0;
//        String comment = "";


      if(tree.getSelectionPath() == null || tree.getSelectionPath().toString().length() < 52)
        return null;
      if(path.substring(0, 51).equals("[Document, Element: Signatures, Element: Signature "))
        attrVal = path.substring(51, path.length()-1);
      else
        return null;
      nList= document.getElementsByTagName("Signature");
      for(int i=0; i<nList.getLength(); i++){
        if(nList.item(i).getAttributes().item(0).getNodeValue().equals(attrVal)){
          node = nList.item(i);
          break;
        }
        else if(i == nList.getLength()-1)
          return null;
      }

      nodeList = node.getChildNodes();
      for(int i=0; i<nodeList.getLength(); i++) {
        String name = nodeList.item(i).getNodeName();
        if(name.equalsIgnoreCase("Enabled") && nodeList.item(i).getFirstChild()!=null) {
          cs.cidss.enabled = Boolean.getBoolean(nodeList.item(i).getFirstChild().getNodeValue());
        } else if(name.equalsIgnoreCase("Sig_source") && nodeList.item(i).getFirstChild()!=null) {
          cs.cidss.sig_source = nodeList.item(i).getFirstChild().getNodeValue();
        } else if (name.equalsIgnoreCase("Description") && nodeList.item(i).getFirstChild()!=null) {
          cs.cidss.description = nodeList.item(i).getFirstChild().getNodeValue();
        } else if (name.equalsIgnoreCase("Action") && nodeList.item(i).getFirstChild()!=null) {
          cs.cidss.action = nodeList.item(i).getFirstChild().getNodeValue();
        } else if (name.equalsIgnoreCase("Message") && nodeList.item(i).getFirstChild()!=null) {
          cs.cidss.message = nodeList.item(i).getFirstChild().getNodeValue();
        } else if (name.equalsIgnoreCase("Logged_packets") && nodeList.item(i).getFirstChild()!=null) {
          cs.cidss.logged_packets = Integer.parseInt(nodeList.item(i).getFirstChild().getNodeValue());
        } else if (name.equalsIgnoreCase("Comment") && nodeList.item(i).getFirstChild()!=null) {
          cs.cidss.comment.add(nodeList.item(i).getFirstChild().getNodeValue());
        }
/*
        else if (name.equalsIgnoreCase("Sources")) {
          nodeSHosts = nodeList.item(i).getChildNodes();
          for(int j=0; j<nodeSHosts.getLength(); j++) {
            String sourceName = nodeSHosts.item(j).getNodeName();
            cidss.Sources.Source s = new cidss.Sources.Source();
            if (sourceName.equalsIgnoreCase("Source_IP")) {
              s.source_ip = nodeSHosts.item(j).getFirstChild().getNodeValue();
              s.source_ip_neg = Boolean.getBoolean(nodeSHosts.item(j).getFirstChild().getAttributes().getNamedItem("Neg").getNodeValue());
            } else if (sourceName.equalsIgnoreCase("Source_Port")) {
              s.source_port = nodeSHosts.item(j).getFirstChild().getNodeValue();
            } else if (sourceName.equalsIgnoreCase("Source_Port_Neg")) {
//              s.source_port_neg = Boolean.getBoolean(nodeSHosts.item(j).getFirstChild().getNodeValue());
            }
            cs.cidss.sources.addSource(s);
          }
        }
        else if (name.equalsIgnoreCase("Pattern")) {
          nodePatt = nodeList.item(i).getChildNodes();
          for(int j=0; j<nodePatt.getLength(); j++) {
            String pattName = nodePatt.item(j).getNodeName();
            if (pattName.equalsIgnoreCase("Pattern_type")) {
              pattern_type = nodePatt.item(j).getFirstChild().getNodeValue();
            } else if (pattName.equalsIgnoreCase("Pattern_content")) {
              pattern = nodePatt.item(j).getFirstChild().getNodeValue();
            } else if (pattName.equalsIgnoreCase("Pattern_neg")) {
              pattern_neg = Boolean.getBoolean(nodePatt.item(j).getFirstChild().getNodeValue());
            }
          }
        }
*/
      }

      return cs;
/*
      return new CommonSignature(action,protocol,sig_source,description,
                                 source_ip, source_ip_neg, destination_ip, destination_ip_neg,
                                 source_port, source_port_neg, destination_port,destination_port_neg,
                                 pattern, pattern_type, pattern_neg, message,
                                 loged_packets, search_depth, comment);
*/
  }
}
